<template>
    <q-card class="card">
        <q-separator :style="kleur" :class="{alarmAnimatie: alarmActief}" />
        <q-tabs v-model="tab" class="text-red">
            <q-tab label="kamer Info" name="kamer" />
            <q-tab label="Patiënt" v-if="patient != null" name="patient" />
        </q-tabs>

        <q-separator />

        <q-tab-panels v-model="tab" animated>
            <q-tab-panel name="kamer" @click="$emit('goToPatient',patient.id)">
                <q-card-section v-show="settings.nummer">
                    <div class="text-h3">Kamer {{kamer.id}}</div>
                </q-card-section>
                <q-separator inset v-show="settings.faciliteiten" />
                <q-card-section v-show="settings.faciliteiten">
                    <q-icon class="icon" v-for="naamfacil in kamer.faciliteiten" :key="naamfacil" :name="naamfacil" />
                </q-card-section>

                <q-separator inset v-if="patient == null" />
                <q-card-section v-if="patient == null">
                    <div class="text-h6">kamer is vrij</div>
                </q-card-section>
            </q-tab-panel>

            <q-tab-panel name="patient" @click="$emit('goToPatient',patient.id)" v-if="patient != null">
                <q-card-section v-show="settings.patiënt">
                    <q-avatar size="100px">
                        <img :src="'http://localhost:3000/images/'+ patient.foto">
                    </q-avatar>
                    <div class="text-subtitle2">{{patient.naam}}</div>
                    <div class="text-weight-light">{{patient.redenOpname}}</div>
                </q-card-section>

                <q-card-section v-show="settings.monitoringData">
                    <p>
                        Hartslag:
                        <strong>{{patient.hartslag}}</strong>
                    </p>
                    <p>
                        Bloeddruk:
                        <strong>{{patient.bloeddruk}}</strong>
                    </p>
                </q-card-section>
                <q-card-section v-show="settings.eerstvolgendeActie">
                    <div class="text-h6">Volgende Actie</div>
                    <p>
                        Tijdstip:
                        <strong>{{eerstVolgendeActie.tijdstip}}</strong>
                    </p>
                    <p>
                        Actie:
                        <strong>{{eerstVolgendeActie.type}}</strong>
                    </p>
                </q-card-section>
            </q-tab-panel>
        </q-tab-panels>
    </q-card>
</template>

<style>
.card
{
  margin-top: 15px;
  min-width: 270px;
  margin: 10px;
  text-align: center;
  cursor: pointer;
}
.icon {
  font-size: 25px;
  margin-left: 11px;
}
</style>

<script>
import Utils from '../utils'

export default {
  name: 'RoomCard',
  data () {
    return {
      tab: 'kamer',
      settings: this.$store.getters['settings/settings'],
      color: this.backgroundColor
    }
  },
  props: {
    kamer: Object,
    patient: [Object, Function],
    eerstVolgendeActie: [Object, Function],
    backgroundColor: [Object, String],
    alarmActief: Boolean
  },
  methods: {
    // dit wordt gebruikt om een te veranderen van kleur voor de alarm animatie
    alarmColor () {
      if (this.color === 'background-color:white') {
        this.color = 'background-color:' + this.settings.kleuren.alarm
      } else {
        this.color = 'background-color:white'
      }
    }
  },
  watch: {
    // als er een drempelwaarde wordt overgeschreden dan zal dit toegevoegd worden in de array [arrayAlarm] bij de pagina 'Afdeling'
    patient () {
      if (this.patient.hartslag < this.settings.minHart || this.patient.hartslag > this.settings.maxHart) {
        this.$emit('pushToArray', true)
      } else if (this.patient.bloeddruk < this.settings.minBloed || this.patient.bloeddruk > this.settings.maxBloed) {
        this.$emit('pushToArray', true)
      } else {
        this.$emit('pushToArray', false)
      }
    },
    // zelfgemaakte manier om een animatie te maken voor het alarm met een kleur naar keuze die je bij de instellingen kan aanpassen
    alarmActief () {
      if (this.alarmActief === true) {
        this.test = true
        setInterval(this.alarmColor, 700)
      } else {
        clearInterval(this.alarmColor, 700)
      }
    },
    // indien er een eerst volgende actie is zal er een gradient verschijnen aan de bovenkant van de lijst (zie streep) en bij het balkje wanneer je de map bekijkt
    eerstVolgendeActie () {
      if (this.eerstVolgendeActie !== undefined) {
        this.color = Utils.calculateColor(this.eerstVolgendeActie, this.settings, this.kamer, this.alarmActief)
      }
    }
  },
  computed: {
    kleur () {
      return this.color
    },
    getAlarmActief () {
      return this.alarmActief
    }
  }
}

</script>
